package kaysaar.aotd_question_of_loyalty.data.scripts.rulesInterceptor;

import java.util.Iterator;
import java.util.List;
import com.fs.starfarer.api.Global;
import kaysaar.aotd_question_of_loyalty.data.tags.AoTDRankTags;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import kaysaar.aotd_question_of_loyalty.data.misc.QoLMisc;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;

public class TalkWayFromScanScript extends BaseReplaceScript
{
    public boolean shouldInsert(final InteractionDialogAPI dialogAPI) {
        final boolean goodOpton = dialogAPI.getOptionPanel().hasOption((Object)"tOff_comply2") || dialogAPI.getOptionPanel().hasOption((Object)"tOff_comply") || dialogAPI.getOptionPanel().hasOption((Object)"cargoScan_comply");
        return goodOpton && QoLMisc.isCommissionedBy(dialogAPI.getInteractionTarget().getFaction().getId()) && AoTDCommIntelPlugin.get().getCurrentRankData().hasTag(AoTDRankTags.CAN_INTIMIDATE_CARGO_PATROL_FLEETS);
    }
    
    @Override
    public void advance(final float amount) {
        if (Global.getSector().getCampaignUI().isShowingDialog()) {
            final InteractionDialogAPI dialog = Global.getSector().getCampaignUI().getCurrentInteractionDialog();
            if (dialog != null) {
                if (this.shouldInsert(dialog) && !this.isInInteraction) {
                    this.isInInteraction = true;
                    final List list = dialog.getOptionPanel().getSavedOptionList();
                    dialog.getOptionPanel().clearOptions();
                    dialog.getOptionPanel().addOption("I would not recommend that if I were you", (Object)"aotd_refuse_scan", AoTDCommIntelPlugin.optionColor, "We can intimidate this officer due to our rank within faction");
                    final List list2 = dialog.getOptionPanel().getSavedOptionList();
                    final Object obj = list2.get(0);
                    final List list3 = dialog.getOptionPanel().getSavedOptionList();
                    list3.clear();
                    dialog.getOptionPanel().clearOptions();
                    int i = 0;
                    for (final Object o : list) {
                        if (i == 2) {
                            list3.add(obj);
                        }
                        list3.add(o);
                        ++i;
                    }
                    dialog.getOptionPanel().restoreSavedOptions(list3);
                }
                else if (!dialog.getOptionPanel().hasOption((Object)"aotd_refuse_scan")) {
                    this.isInInteraction = false;
                }
            }
        }
        else {
            this.isInInteraction = false;
        }
    }
}
